module networker;

import message;

class Networker
{
private:
    import std.net.curl : get, post;

    string p_serverUrl;
public:

    this(string serverUrl)
    {
        this.p_serverUrl = serverUrl;
    }

    void postMessage(Message msg)
    {
        auto content = post(p_serverUrl ~ "/add-message", msg);
    }

    Message[] getMessagesForRecipient(string b64_publickey)
    {
        import std.conv : to;
        import std.json : parseJSON, JSONValue, JSONException;

        Message[] msgs;

        auto queryParams = ["pubkey": b64_publickey];
        auto content = post(p_serverUrl ~ "/getmessages", queryParams);

        auto json = parseJSON(to!string(content));
        foreach (msg_json; json.array)
        {
            try
            {
                Message single_msg = [
                    "recipient": msg_json["recipient"].str,
                    "payload": msg_json["payload"].str
                ];

                msgs ~= single_msg;
            }
            catch(Exception ex)
            {
                continue;
            }
        }

        return msgs;
    }
}